<template>
  <AppMainCard
    text-root="registration"
    :type="type"
  >
    <RegistrationFeedback
      v-if="success || fail"
      :button-text="$t('registration.returnToHome')"
      :success="success"
      text-root="registration.infoCard"
      @click="navigateTo('/')"
    />
    <RegistrationForm
      v-else
      v-model="email"
      :has-error="formHasError"
      :errors="formErrors"
      :loading="loading"
      :valid-form="validForm"
      @click="sendForm"
    />
  </AppMainCard>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import useVuelidate, { ErrorObject } from '@vuelidate/core'
import { required, email } from '@vuelidate/validators'
import { AlertType } from '~/utility/constant'

export default defineComponent({
  name: 'RegistrationPage',
  setup() {
    return { v$: useVuelidate() }
  },
  data() {
    return {
      email: '',
      sessionId: '',
      fail: false,
      formErrors: [] as ErrorObject[],
      formHasError: false,
      loading: false,
      success: false,
      timeout: 0,
      validForm: false
    }
  },
  computed: {
    type() {
      if (this.success) { return AlertType.INFO }
      if (this.fail) { return AlertType.ERROR }
      return AlertType.DEFAULT
    }
  },
  watch: {
    email() {
      this.v$.$touch()
      this.validForm = !this.v$.$invalid
      this.debounceEmailInput()
    }
  },
  created() {
    const { sessionId } = this.$route.query
    if (sessionId) {
      this.sessionId = String(sessionId)
    }
  },
  validations() {
    return {
      email: { required, email }
    }
  },
  beforeUnmount() { clearInterval(this.timeout) },
  methods: {
    debounceEmailInput() {
      if (this.validForm) {
        this.formHasError = false
        this.formErrors = []
      }
      if (this.timeout) { clearTimeout(this.timeout) }

      this.timeout = window.setTimeout(() => {
        this.formHasError = (this.v$ as any).email.$error
        this.formErrors = (this.v$ as any).email.$errors
      }, 1000)
    },
    sendForm() {
      if (this.success) { return }
      this.loading = true
      if (!this.validForm) {
        this.loading = false
        return
      }

      const payload: any = { email: this.email }
      if (this.sessionId) {
        payload.sessionId = this.sessionId
      }

      const requestOptions = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(payload)
      }
      const baseURI = 'https://issuer-api.lab.gaia-x.eu'

      fetch(`${baseURI}/mails`, requestOptions)
        .then(() => {
          this.success = true
        })
        .catch(() => {
          this.fail = true
        })
        .finally(() => {
          this.loading = false
        })
    }
  }
})
</script>

<style>
</style>
